<?php
/**
 * ConfigServiceApi
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * rest.proto
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: version not set
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Api;

use \Swagger\Client\ApiClient;
use \Swagger\Client\ApiException;
use \Swagger\Client\Configuration;
use \Swagger\Client\ObjectSerializer;

/**
 * ConfigServiceApi Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class ConfigServiceApi
{
    /**
     * API Client
     *
     * @var \Swagger\Client\ApiClient instance of the ApiClient
     */
    protected $apiClient;

    /**
     * Constructor
     *
     * @param \Swagger\Client\ApiClient|null $apiClient The api client to use
     */
    public function __construct(\Swagger\Client\ApiClient $apiClient = null)
    {
        if ($apiClient === null) {
            $apiClient = new ApiClient();
        }

        $this->apiClient = $apiClient;
    }

    /**
     * Get API client
     *
     * @return \Swagger\Client\ApiClient get the API client
     */
    public function getApiClient()
    {
        return $this->apiClient;
    }

    /**
     * Set the API client
     *
     * @param \Swagger\Client\ApiClient $apiClient set the API client
     *
     * @return ConfigServiceApi
     */
    public function setApiClient(\Swagger\Client\ApiClient $apiClient)
    {
        $this->apiClient = $apiClient;
        return $this;
    }

    /**
     * Operation controlService
     *
     * @param \Swagger\Client\Model\RestControlServiceRequest $body  (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\RestService
     */
    public function controlService($body)
    {
        list($response) = $this->controlServiceWithHttpInfo($body);
        return $response;
    }

    /**
     * Operation controlServiceWithHttpInfo
     *
     * @param \Swagger\Client\Model\RestControlServiceRequest $body  (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\RestService, HTTP status code, HTTP response headers (array of strings)
     */
    public function controlServiceWithHttpInfo($body)
    {
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling controlService');
        }
        // parse inputs
        $resourcePath = "/config/ctl";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json']);

        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\RestService',
                '/config/ctl'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\RestService', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\RestService', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation deleteDataSource
     *
     * @param string $ds_name  (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\RestDeleteDataSourceResponse
     */
    public function deleteDataSource($ds_name)
    {
        list($response) = $this->deleteDataSourceWithHttpInfo($ds_name);
        return $response;
    }

    /**
     * Operation deleteDataSourceWithHttpInfo
     *
     * @param string $ds_name  (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\RestDeleteDataSourceResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function deleteDataSourceWithHttpInfo($ds_name)
    {
        // verify the required parameter 'ds_name' is set
        if ($ds_name === null) {
            throw new \InvalidArgumentException('Missing the required parameter $ds_name when calling deleteDataSource');
        }
        // parse inputs
        $resourcePath = "/config/datasource/{DsName}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json']);

        // path params
        if ($ds_name !== null) {
            $resourcePath = str_replace(
                "{" . "DsName" . "}",
                $this->apiClient->getSerializer()->toPathValue($ds_name),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'DELETE',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\RestDeleteDataSourceResponse',
                '/config/datasource/{DsName}'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\RestDeleteDataSourceResponse', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\RestDeleteDataSourceResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation get
     *
     * @param string $full_path  (required)
     * @param string $data  (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\RestConfiguration
     */
    public function get($full_path, $data = null)
    {
        list($response) = $this->getWithHttpInfo($full_path, $data);
        return $response;
    }

    /**
     * Operation getWithHttpInfo
     *
     * @param string $full_path  (required)
     * @param string $data  (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\RestConfiguration, HTTP status code, HTTP response headers (array of strings)
     */
    public function getWithHttpInfo($full_path, $data = null)
    {
        // verify the required parameter 'full_path' is set
        if ($full_path === null) {
            throw new \InvalidArgumentException('Missing the required parameter $full_path when calling get');
        }
        // parse inputs
        $resourcePath = "/config/{FullPath}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json']);

        // query params
        if ($data !== null) {
            $queryParams['Data'] = $this->apiClient->getSerializer()->toQueryValue($data);
        }
        // path params
        if ($full_path !== null) {
            $resourcePath = str_replace(
                "{" . "FullPath" . "}",
                $this->apiClient->getSerializer()->toPathValue($full_path),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\RestConfiguration',
                '/config/{FullPath}'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\RestConfiguration', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\RestConfiguration', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation getDataSource
     *
     * @param string $ds_name  (required)
     * @param string $type  (optional, default to LOCAL)
     * @param int $objects_port  (optional)
     * @param string $local_folder  (optional)
     * @param bool $local_mac_os  (optional)
     * @param bool $watch  (optional)
     * @param string $encryption_mode  (optional, default to CLEAR)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\RestDataSource
     */
    public function getDataSource($ds_name, $type = 'LOCAL', $objects_port = null, $local_folder = null, $local_mac_os = null, $watch = null, $encryption_mode = 'CLEAR')
    {
        list($response) = $this->getDataSourceWithHttpInfo($ds_name, $type, $objects_port, $local_folder, $local_mac_os, $watch, $encryption_mode);
        return $response;
    }

    /**
     * Operation getDataSourceWithHttpInfo
     *
     * @param string $ds_name  (required)
     * @param string $type  (optional, default to LOCAL)
     * @param int $objects_port  (optional)
     * @param string $local_folder  (optional)
     * @param bool $local_mac_os  (optional)
     * @param bool $watch  (optional)
     * @param string $encryption_mode  (optional, default to CLEAR)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\RestDataSource, HTTP status code, HTTP response headers (array of strings)
     */
    public function getDataSourceWithHttpInfo($ds_name, $type = 'LOCAL', $objects_port = null, $local_folder = null, $local_mac_os = null, $watch = null, $encryption_mode = 'CLEAR')
    {
        // verify the required parameter 'ds_name' is set
        if ($ds_name === null) {
            throw new \InvalidArgumentException('Missing the required parameter $ds_name when calling getDataSource');
        }
        // parse inputs
        $resourcePath = "/config/datasource/{DsName}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json']);

        // query params
        if ($type !== null) {
            $queryParams['Type'] = $this->apiClient->getSerializer()->toQueryValue($type);
        }
        // query params
        if ($objects_port !== null) {
            $queryParams['ObjectsPort'] = $this->apiClient->getSerializer()->toQueryValue($objects_port);
        }
        // query params
        if ($local_folder !== null) {
            $queryParams['LocalFolder'] = $this->apiClient->getSerializer()->toQueryValue($local_folder);
        }
        // query params
        if ($local_mac_os !== null) {
            $queryParams['LocalMacOS'] = $this->apiClient->getSerializer()->toQueryValue($local_mac_os);
        }
        // query params
        if ($watch !== null) {
            $queryParams['Watch'] = $this->apiClient->getSerializer()->toQueryValue($watch);
        }
        // query params
        if ($encryption_mode !== null) {
            $queryParams['EncryptionMode'] = $this->apiClient->getSerializer()->toQueryValue($encryption_mode);
        }
        // path params
        if ($ds_name !== null) {
            $resourcePath = str_replace(
                "{" . "DsName" . "}",
                $this->apiClient->getSerializer()->toPathValue($ds_name),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\RestDataSource',
                '/config/datasource/{DsName}'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\RestDataSource', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\RestDataSource', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation listDataSources
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\RestDataSourceCollection
     */
    public function listDataSources()
    {
        list($response) = $this->listDataSourcesWithHttpInfo();
        return $response;
    }

    /**
     * Operation listDataSourcesWithHttpInfo
     *
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\RestDataSourceCollection, HTTP status code, HTTP response headers (array of strings)
     */
    public function listDataSourcesWithHttpInfo()
    {
        // parse inputs
        $resourcePath = "/config/datasource";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json']);


        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\RestDataSourceCollection',
                '/config/datasource'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\RestDataSourceCollection', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\RestDataSourceCollection', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation listServices
     *
     * @param string $status_filter  (optional, default to ANY)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\RestServiceCollection
     */
    public function listServices($status_filter = 'ANY')
    {
        list($response) = $this->listServicesWithHttpInfo($status_filter);
        return $response;
    }

    /**
     * Operation listServicesWithHttpInfo
     *
     * @param string $status_filter  (optional, default to ANY)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\RestServiceCollection, HTTP status code, HTTP response headers (array of strings)
     */
    public function listServicesWithHttpInfo($status_filter = 'ANY')
    {
        // parse inputs
        $resourcePath = "/config/ctl";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json']);

        // query params
        if ($status_filter !== null) {
            $queryParams['StatusFilter'] = $this->apiClient->getSerializer()->toQueryValue($status_filter);
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\RestServiceCollection',
                '/config/ctl'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\RestServiceCollection', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\RestServiceCollection', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation put
     *
     * @param string $full_path  (required)
     * @param \Swagger\Client\Model\RestConfiguration $body  (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\RestConfiguration
     */
    public function put($full_path, $body)
    {
        list($response) = $this->putWithHttpInfo($full_path, $body);
        return $response;
    }

    /**
     * Operation putWithHttpInfo
     *
     * @param string $full_path  (required)
     * @param \Swagger\Client\Model\RestConfiguration $body  (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\RestConfiguration, HTTP status code, HTTP response headers (array of strings)
     */
    public function putWithHttpInfo($full_path, $body)
    {
        // verify the required parameter 'full_path' is set
        if ($full_path === null) {
            throw new \InvalidArgumentException('Missing the required parameter $full_path when calling put');
        }
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling put');
        }
        // parse inputs
        $resourcePath = "/config/{FullPath}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json']);

        // path params
        if ($full_path !== null) {
            $resourcePath = str_replace(
                "{" . "FullPath" . "}",
                $this->apiClient->getSerializer()->toPathValue($full_path),
                $resourcePath
            );
        }
        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'PUT',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\RestConfiguration',
                '/config/{FullPath}'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\RestConfiguration', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\RestConfiguration', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation putDataSource
     *
     * @param string $ds_name  (required)
     * @param \Swagger\Client\Model\RestDataSource $body  (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\RestDataSource
     */
    public function putDataSource($ds_name, $body)
    {
        list($response) = $this->putDataSourceWithHttpInfo($ds_name, $body);
        return $response;
    }

    /**
     * Operation putDataSourceWithHttpInfo
     *
     * @param string $ds_name  (required)
     * @param \Swagger\Client\Model\RestDataSource $body  (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\RestDataSource, HTTP status code, HTTP response headers (array of strings)
     */
    public function putDataSourceWithHttpInfo($ds_name, $body)
    {
        // verify the required parameter 'ds_name' is set
        if ($ds_name === null) {
            throw new \InvalidArgumentException('Missing the required parameter $ds_name when calling putDataSource');
        }
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling putDataSource');
        }
        // parse inputs
        $resourcePath = "/config/datasource/{DsName}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json']);

        // path params
        if ($ds_name !== null) {
            $resourcePath = str_replace(
                "{" . "DsName" . "}",
                $this->apiClient->getSerializer()->toPathValue($ds_name),
                $resourcePath
            );
        }
        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\RestDataSource',
                '/config/datasource/{DsName}'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\RestDataSource', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\RestDataSource', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }
}
