/*
 * Copyright 2007-2017 Charles du Jeu - Abstrium SAS <team (at) pyd.io>
 * This file is part of Pydio.
 *
 * Pydio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Pydio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with Pydio.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The latest code can be found at <https://pydio.com>.
 */

class AS2Client{

    static loadActivityStreams(callback = function(json){}, context = 'USER_ID', contextData = '', boxName = 'outbox', pointOfView = '') {

        if (!contextData) {
            return;
        }
        let params = {
            get_action:'streams',
            context : context,
            contextData: contextData,
            boxName: boxName,
        };
        if (pointOfView) {
            params['pointOfView'] = pointOfView;
        }
        PydioApi.getClient().request(params, function(transport){
            callback(transport.responseJSON);
        })

    }

    static UnreadInbox(userId, callback = function(count){}) {

        PydioApi.getClient().request({
            get_action:'streams',
            context : 'USER_ID',
            contextData: userId,
            boxName: 'inbox',
            unreadCountOnly: 'true'
        }, function(transport){
            let data = transport.responseJSON;
            let count = data.totalItems || 0;
            callback(count);
        })

    }

}

export {AS2Client as default};
