/*
 * Copyright 2007-2017 Charles du Jeu - Abstrium SAS <team (at) pyd.io>
 * This file is part of Pydio.
 *
 * Pydio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Pydio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with Pydio.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The latest code can be found at <https://pydio.com>.
 */

'use strict';

exports.__esModule = true;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _require$requireLib = require('pydio').requireLib('boot');

var PydioContextConsumer = _require$requireLib.PydioContextConsumer;
var moment = _require$requireLib.moment;

var Message = (function (_React$Component) {
    _inherits(Message, _React$Component);

    function Message() {
        _classCallCheck(this, Message);

        _React$Component.apply(this, arguments);
    }

    Message.prototype.render = function render() {
        var _props = this.props;
        var message = _props.message;
        var pydio = _props.pydio;

        var mDate = moment(parseFloat(message.Timestamp) * 1000);

        return _react2['default'].createElement(
            'div',
            { className: 'comment' },
            _react2['default'].createElement(
                'div',
                { className: 'date' },
                mDate.fromNow()
            ),
            _react2['default'].createElement(
                'div',
                { className: 'comment-line' },
                _react2['default'].createElement(
                    'div',
                    { style: { paddingTop: 2 } },
                    _react2['default'].createElement(PydioComponents.UserAvatar, { avatarSize: 30, pydio: this.props.pydio, userId: message.Author, displayLabel: false })
                ),
                _react2['default'].createElement(
                    MaterialUI.Paper,
                    { zDepth: 0, style: { backgroundColor: '#F5F5F5' }, className: 'content' },
                    message.Message
                )
            )
        );
    };

    return Message;
})(_react2['default'].Component);

Message.PropTypes = {
    message: _react2['default'].PropTypes.object
};

exports['default'] = Message = PydioContextConsumer(Message);
exports['default'] = Message;
module.exports = exports['default'];
