/*
 * Copyright 2007-2017 Charles du Jeu - Abstrium SAS <team (at) pyd.io>
 * This file is part of Pydio.
 *
 * Pydio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Pydio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with Pydio.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The latest code can be found at <https://pydio.com>.
 */

'use strict';

exports.__esModule = true;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _materialUi = require('material-ui');

var _require$requireLib = require('pydio').requireLib('boot');

var PydioContextConsumer = _require$requireLib.PydioContextConsumer;

var Pydio9Card = (function (_Component) {
    _inherits(Pydio9Card, _Component);

    function Pydio9Card() {
        _classCallCheck(this, Pydio9Card);

        _Component.apply(this, arguments);
    }

    Pydio9Card.prototype.openDocs = function openDocs() {
        open("http://pydio9-tech-preview.readthedocs.io/");
    };

    Pydio9Card.prototype.openSlack = function openSlack() {
        open("https://join.slack.com/t/pydio9/shared_invite/enQtMjgwNjg4NzY3NDQwLTJlNzUxYTZiMDVjMWNjYTg0NDMxZjQxMWM0NmQ1ZmEyYjVjOTI5NjM0ODEwNmFlODkyMDBhYmU4NmJiOWU5MTk");
    };

    Pydio9Card.prototype.openGithub = function openGithub() {
        open("https://github.com/pydio/pydio9-beta-docs/issues");
    };

    Pydio9Card.prototype.render = function render() {
        var _props = this.props;
        var pydio = _props.pydio;
        var style = _props.style;

        var imgBase = pydio.Parameters.get('ajxpResourcesFolder') + '/themes/common/images';

        return React.createElement(
            _materialUi.Card,
            { style: style },
            React.createElement(
                _materialUi.CardMedia,
                null,
                React.createElement('img', { src: imgBase + "/Pydio9-arch.png" })
            ),
            React.createElement(_materialUi.CardTitle, { title: 'Welcome to Pydio9 Beta', subtitle: 'This is a tech preview of Pydio9' }),
            React.createElement(
                _materialUi.CardText,
                null,
                'Thank you for taking the time to take a glance at the future of Pydio! This version is a technology preview, please beware that it is ',
                React.createElement(
                    'u',
                    null,
                    'NOT PRODUCTION READY'
                ),
                '! Particularly on the security level, the backend API\'s are not secured yet. ',
                React.createElement('br', null),
                React.createElement('br', null),
                'Pydio 9 is a full rewrite of the PHP server into #Go, the server language used by Google on their own datacenters all over the world. It is designed with scalability and open standards in mind, and based on a micro-services architecture. Please refer to the dedicated documentation to read more about this new architecture and how you can help testing it.'
            ),
            React.createElement(_materialUi.Divider, null),
            React.createElement(
                _materialUi.CardActions,
                null,
                React.createElement(_materialUi.FlatButton, { primary: true, icon: React.createElement(_materialUi.FontIcon, { className: 'mdi mdi-book-variant' }), label: 'P9 Docs', onTouchTap: this.openDocs }),
                React.createElement(_materialUi.FlatButton, { primary: true, icon: React.createElement(_materialUi.FontIcon, { className: 'mdi mdi-slack' }), label: 'Channel', onTouchTap: this.openSlack }),
                React.createElement(_materialUi.FlatButton, { primary: true, icon: React.createElement(_materialUi.FontIcon, { className: 'mdi mdi-github-box' }), label: 'Issues', onTouchTap: this.openGithub })
            )
        );
    };

    return Pydio9Card;
})(_react.Component);

exports['default'] = Pydio9Card = PydioContextConsumer(Pydio9Card);

exports['default'] = Pydio9Card;
module.exports = exports['default'];
