/*
 * Copyright 2007-2017 Charles du Jeu - Abstrium SAS <team (at) pyd.io>
 * This file is part of Pydio.
 *
 * Pydio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Pydio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with Pydio.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The latest code can be found at <https://pydio.com>.
 */

import React from 'react'
const {PydioContextConsumer, moment} = require('pydio').requireLib('boot');

class Message extends React.Component {

    render(){
        const {message, pydio} = this.props;
        let mDate = moment(parseFloat(message.Timestamp)*1000);

        return (
            <div className="comment">
                <div className="date">{mDate.fromNow()}</div>
                <div className="comment-line">
                    <div style={{paddingTop:2}}><PydioComponents.UserAvatar avatarSize={30} pydio={this.props.pydio} userId={message.Author} displayLabel={false}/></div>
                    <MaterialUI.Paper zDepth={0} style={{backgroundColor: '#F5F5F5'}} className="content">
                        {message.Message}
                    </MaterialUI.Paper>
                </div>
            </div>
        );
    }
}

Message.PropTypes = {
    message : React.PropTypes.object
};

Message = PydioContextConsumer(Message);
export {Message as default};